---
AWSTemplateFormatVersion: '2010-09-09'
Description: VPN Gateway and VPN connections for VPC
Parameters:
  EnvironmentAbbr:
    Description: Environment abbreviation used to import stack outputs
    Type: String

Resources:
  VPNGateway:
    Type: AWS::EC2::VPNGateway
    Properties:
      Type         : "ipsec.1"
      AmazonSideAsn: {{ amazon_side_asn if (amazon_side_asn | length > 0) else "!Ref AWS::NoValue" }}
      Tags:
        - Key: Name
          Value: !Sub "${EnvironmentAbbr} VPN Gateway"

  VPCGatewayAttachment:
    Type: AWS::EC2::VPCGatewayAttachment
    Properties:
      VpcId:
        Fn::ImportValue: !Sub "${EnvironmentAbbr}-vpc-VpcId"
      VpnGatewayId: !Ref VPNGateway

{% if propagate_routes.private and aws_vpc_params.private_subnet_weight > 0 %}
  VPNGatewayRoutePropagationPrivate:
    DependsOn: VPCGatewayAttachment
    Type: AWS::EC2::VPNGatewayRoutePropagation
    Properties:
      RouteTableIds: !Split [',', {'Fn::ImportValue': !Sub "${EnvironmentAbbr}-vpc-RouteTablesPrivate"}]
      VpnGatewayId: !Ref VPNGateway
{% endif %}

{% if propagate_routes.database and aws_vpc_params.database_subnet_weight > 0 %}
  VPNGatewayRoutePropagationDatabase:
    DependsOn: VPCGatewayAttachment
    Type: AWS::EC2::VPNGatewayRoutePropagation
    Properties:
      RouteTableIds: !Split [',', {'Fn::ImportValue': !Sub "${EnvironmentAbbr}-vpc-RouteTablesDatabase"}]
      VpnGatewayId: !Ref VPNGateway
{% endif %}

{% if propagate_routes.public and aws_vpc_params.public_subnet_weight > 0 %}
  VPNGatewayRoutePropagationPublic:
    DependsOn: VPCGatewayAttachment
    Type: AWS::EC2::VPNGatewayRoutePropagation
    Properties:
      RouteTableIds: !Split [',', {'Fn::ImportValue': !Sub "${EnvironmentAbbr}-vpc-RouteTablesPublic"}]
      VpnGatewayId: !Ref VPNGateway
{% endif %}

{% for name, vpn in vpns.items() %}
  {{ name|replace(' ', '') }}VPN:
    Type: "AWS::EC2::VPNConnection"
    Properties:
      Type: ipsec.1
      StaticRoutesOnly: {{ vpn.static_routes_only | default('false') }}
      CustomerGatewayId:
        Fn::ImportValue: "cgw-{{ name|replace(' ', '') }}Gateway"
      VpnGatewayId: !Ref VPNGateway
{% if 'tunnel_inside_cidrs' in vpns[name] %}
      VpnTunnelOptionsSpecifications:
        - TunnelInsideCidr: {{ vpns[name]['tunnel_inside_cidrs'][0] }}
        - TunnelInsideCidr: {{ vpns[name]['tunnel_inside_cidrs'][1] }}
{% endif %}
      Tags:
        - Key: Name
          Value: {{ name }}

{% endfor %}
